//MINGOLLA DANIELE              MATRICOLA N. 300738

#include "gamelib.h"

//PROTOTIPI DELLE FUNZIONI NECESSARIE

//cancella la zona in coda
static void canc_zona();
//scorre la lista dalla testa fino alla coda stampando il tipo di zona o l'oggetto presente al suo interno
static void stampa_mappa();
//inserisce una nuova zona in coda
static void ins_zona();
//consente di chiudere la mappa dopo aver verificato che l'ultima zona sia l'uscita e che ci siano almeno 8 zone
static void chiudi_mappa();
//permette la creazione del percorso,la cancellazione delle terre partendo dalla coda,la stampa del percorso creato,la sua chiusura ed il ritorno al menu iniziale quando il percorso è chiuso
void crea_mappa();
//la zona corrente del giocatore diventa la zona successiva,cioè avanza
static void avanza(struct Giocatore*);
//in base all'oggetto presente nella zona resituisce un messaggio
static void mostra_oggetto(struct Zona*);
//incrementa la quantità di un determinato oggetto nello zaino di +1,verifica che non si superino le quantità definite e una volta preso l'oggetto esso diventa una cianfrusaglia
static void prendi_oggetto(struct Zona*,struct Giocatore*);
//verifica che il giocatore abbia delle bende e se è ferito,ripristina il suo stato di salute
static void cura(struct Giocatore*);
//permette di effettuare due mosse consecutive
static void usa_adrenalina(struct Giocatore*);
//resetta gli zaini e lo stato di salute di entrambi i giocatori al termine della partita
static void reset();
//gestisce le probabilità di apparizione di gieson in base a dove i giocatori si trovano e al loro stato di salute
static void gieson(struct Giocatore*);
//in base alla tipologia di zona si posiziona sulla corrispettiva riga sommando man mano tutti i valori contenuti in quella riga e verificando. In base al valore della probabiità passato come paramentro,resituisce il corrispettivo oggetto
static enum Tipo_oggetto p_oggetto(enum Tipo_zona zona,int probabilita);

//puntatori rispettivamente alla prima zona e all'ultima zona
static struct Zona* prima_zona=NULL;
static struct Zona* ultima_zona=NULL;

//inizializzazione dei giocatori e dei loro zaini
static struct Giocatore marzia = {vivo,NULL,.zaino[adrenalina]=2};
static struct Giocatore giacomo ={vivo,NULL,.zaino[coltello]=1};
//matrice contentenente le probabilità di trovare un determinato oggetto in una determinata zona
static const int mat[6][6]={{30,20,40,0,0,10},{20,10,10,30,0,30},
                            {20,10,30,0,30,10},{80,0,10,0,10,0},
                            {70,0,10,0,20,0},{90,0,10,0,0,0}};

//gestione delle varie mosse che il giocatore può effettuare
static void turnogiacomo();
static void turnomarzia();

//utile per una gestione migliore della chiusura/apertura del percorso,è utilizzato da più funzioni
static enum lucchetto {closed,opened} lucchetto = opened;
static short int numeronodi=0; //utile per verificare che anche in casi di cancellazione,i nodi siano MINIMO 8,è utilizzato da più funzioni
static short int vistogiacomo=0,vistomarzia=0; //diventa 1 se l'oggetto è stato cercato,non si può raccogliere l'oggetto senza prima averlo visto/conoscerlo,è utilizzato da più funzioni
static short int vittoriag=0,vittoriam=0; //flag diventano 1 quando rispettivamente vincono giacomo e/o marzia,è utilizzato da più funzioni

static void reset(){
    lucchetto=opened;
    vittoriag=0;
    vittoriam=0;
    marzia.stato=vivo;
    giacomo.stato=vivo;
    marzia.zaino[cianfrusaglia]=0;
    marzia.zaino[bende]=0;
    marzia.zaino[coltello]=0;
    marzia.zaino[pistola]=0;
    marzia.zaino[benzina]=0;
    giacomo.zaino[cianfrusaglia]=0;
    giacomo.zaino[bende]=0;
    giacomo.zaino[pistola]=0;
    giacomo.zaino[benzina]=0;
    giacomo.zaino[adrenalina]=0;
    marzia.zaino[adrenalina]=2;
    giacomo.zaino[coltello]=1;
}

void termina_gioco(){

        //Finchè esiste la prima zona, quindi finchè ci sono altre zone
	while(prima_zona!=NULL){

		//Se la seconda zona è NULL ed è pertanto presente solo la prima zona, libera dalla memoria la prima zona
		if(prima_zona->zona_successiva == NULL){
		free(prima_zona);
		prima_zona=NULL;
		}
  //Se esiste una seconda zona, definisce un puntatore per iniziare dalla prima zona per poi arrivare in fondo alla lista ed eliminare dalla memoria l'ultima zona
    		else{
      			struct Zona *temp = prima_zona;
      			while(temp->zona_successiva->zona_successiva != NULL){
				temp = temp->zona_successiva;
      				}
      			free(temp->zona_successiva);
      			temp->zona_successiva = NULL;
      			}
  }
}

//verifica quanti e quali oggetti si hanno per difendersi,in caso si abbiano più oggetti per difendersi mostra un menu di scelta
static void combattimento(struct Giocatore *player){
    short int scelta;
    unsigned short int repellente=0;
    printf("\033[1;32m");
    if(player->zaino[coltello]>0 || player->zaino[pistola] >0 || player->zaino[benzina] >0 ){

             if(player->zaino[coltello]>0 && player->zaino[pistola] >0 && player->zaino[benzina] >0){
               printf("\n\tCosa vuoi utilizzare?\n\t1)COLTELLO\n\t2)PISTOLA\n\t3)BENZINA\n\tSCELTA: ");
               while (scanf("%hu",&scelta) != 1 || scelta>3 || scelta<1){
                       printf("\n\t SCELTA NON CORRETTA! REINSERISCI LA SCELTA: ");
                       while (getchar() != '\n');
                   }
                   if (scelta == 1 && player->stato == vivo){
                       player->zaino[coltello]--;
                       player->stato =ferito;
                       printf("\n\tUTILIZZI IL COLTELLO MA GIESON RIESCE A FERIRTI!\n");
                   }
                   else if(scelta == 1 && player->stato == ferito){
                       player->zaino[coltello]--;
                       player->stato =morto;
                       printf("\n\tLE INFEZIONI PROVOCATE DALLE VECCHIE FERITE\n\tNON TI PERMETTONO DI CONTINUARE!\n");
                       sleep(2);
                   }
                   else if(scelta == 2){
                       player->zaino[pistola]--;
                       printf("\n\tUTILIZZI LA PISTOLA RIUSCENDO A SPAVENTARE GIESON!\n");
                   }
                   else if(scelta == 3){
                       printf("\n\tUTILIZZI LA BENZINA,PER 4 TURNI GIESON NON APPARIRÀ\n");
                           player->zaino[benzina]--;
                           player->contatore=4;
                   }
           }

        else if(player->zaino[coltello]>0 && player->zaino[pistola]>0){
            printf("\n\tCosa vuoi utilizzare?\n\t1)COLTELLO\n\t2)PISTOLA\n\tSCELTA: ");
            while (scanf("%hu",&scelta) != 1 || scelta>2 || scelta<1){
                    printf("\n\t SCELTA NON CORRETTA! REINSERISCI LA SCELTA: ");
                    while (getchar() != '\n');
                }
                if (scelta == 1 && player->stato == vivo){
                    player->zaino[coltello]--;
                    player->stato =ferito;
                    printf("\n\tUTILIZZI IL COLTELLO MA GIESON RIESCE A FERIRTI!\n");
                }
                else if(scelta == 1 && player->stato == ferito){
                    player->zaino[coltello]--;
                    player->stato =morto;
                    printf("\n\tLE INFEZIONI PROVOCATE DALLE VECCHIE FERITE\n\tNON TI PERMETTONO DI CONTINUARE!\n");
                    sleep(2);
                }
                else if(scelta == 2){
                    player->zaino[pistola]--;
                    printf("\n\tUTILIZZI LA PISTOLA RIUSCENDO A SPAVENTARE GIESON!\n");
                }
        }

        else if(player->zaino[coltello]>0 && player->zaino[benzina]>0){
            printf("\n\tCosa vuoi utilizzare?\n\t1)COLTELLO\n\t2)BENZINA\n\tSCELTA: ");
            while (scanf("%hu",&scelta) != 1 || scelta>2 || scelta<1){
                    printf("\n\t SCELTA NON CORRETTA! REINSERISCI LA SCELTA: ");
                    while (getchar() != '\n');
                }
                if (scelta == 1 && player->stato == vivo){
                    player->zaino[coltello]--;
                    player->stato =ferito;
                    printf("\n\tUTILIZZI IL COLTELLO MA GIESON RIESCE A FERIRTI!\n");
                }
                else if(scelta == 1 && player->stato == ferito){
                    player->zaino[coltello]--;
                    player->stato =morto;
                    printf("\n\tLE INFEZIONI PROVOCATE DALLE VECCHIE FERITE\n\tNON TI PERMETTONO DI CONTINUARE!\n");
                    sleep(2);
                }
                else if(scelta == 2){
                    printf("\n\tUTILIZZI LA BENZINA,PER 4 TURNI GIESON NON APPARIRÀ\n");
                        player->zaino[benzina]--;
                        player->contatore=4;
                }
        }

        else if(player->zaino[benzina]>0 && player->zaino[pistola]>0){
            printf("\n\tCosa vuoi utilizzare?\n\t1)BENZINA\n\t2)PISTOLA\n\tSCELTA: ");
            while (scanf("%hu",&scelta) != 1 || scelta>2 || scelta<1){
                    printf("\n\t SCELTA NON CORRETTA! REINSERISCI LA SCELTA: ");
                    while (getchar() != '\n');
            }
                if(scelta == 1){
                    printf("\n\tUTILIZZI LA BENZINA,PER 4 TURNI GIESON NON APPARIRÀ\n");
                        player->zaino[benzina]--;
                        player->contatore=4;
                }
                else if(scelta == 2){
                    player->zaino[pistola]--;
                    printf("\n\tUTILIZZI LA PISTOLA RIUSCENDO A SPAVENTARE GIESON!\n");
                }
       }



        else  if(player->zaino[coltello] >0 && player->stato == vivo){
              player->zaino[coltello]--;
              player->stato =ferito;
              printf("\n\tUTILIZZI IL COLTELLO MA GIESON RIESCE A FERIRTI!\n");
              sleep(2);
        }

        else if(player->zaino[coltello] >0 && player->stato == ferito){
              player->zaino[coltello]--;
              player->stato =morto;
               printf("\n\tLE INFEZIONI PROVOCATE DALLE VECCHIE FERITE\n\tNON TI PERMETTONO DI CONTINUARE!\n");
               sleep(2);
        }

        else if(player->zaino[pistola] >0){
              player->zaino[pistola]--;
              printf("\n\tUTILIZZI LA PISTOLA RIUSCENDO A SPAVENTARE GIESON!\n");
              sleep(2);
        }

        else if(player->zaino[benzina] >0){
              printf("\n\tUTILIZZI LA BENZINA,PER 4 TURNI GIESON NON APPARIRÀ\n");
                  player->zaino[benzina]--;
                  player->contatore=4;
                  sleep(2);
              }
    }
    else{
        printf("\n\tNON HAI NULLA CON CUI DIFENDERTI,\n\tGIESON TI COLPISCE E NON RIESCI A SOPRAVVIVERE.\n\tGUARDA IL LATO POSITIVO,HAI UN'OTTIMA SCUSA PER NON AVER STUDIATO!\n");
        sleep(2);
        player->stato = morto;
    }
    printf("\033[0m");
}

static void gieson(struct Giocatore *player){
    time_t t;
    srand((unsigned) time(&t));
    int apparizione = 1 + (rand() % 100);
    //se il contatore è >0 significa che è stata utilizzata la benzina,dunque gieson non appare per 4 turni
    if(player->contatore>0){
            player->contatore--;
            if(player->contatore !=0){
                printf("\033[1;32m");
                printf("\n\tEFFETTO DELLA BENZINA: %d\n",player->contatore);
                printf("\033[0m");
            }
    }
    else{
        printf("\033[1;31m");
        //Se uno dei due giocatori muore,la probabilita che gieson appaia arriva al 50%
        if((giacomo.stato == morto || marzia.stato == morto || vittoriag ==1 || vittoriam ==1) && apparizione<=50){
            puts("");
            printf("\n\tHAI PERSO LE TRACCE DEL TUO AMICO,SARÀ MORTO?SARÀ RIUSCITO A FUGGIRE?\n\tNON HAI IL TEMPO DI RISPONDERE QUANDO ALL'IMPROVVISO\n\tAPPARE GIESON CON UN COLTELLO INSANGUINATO!\n");
            sleep(2);
            combattimento(player);
        }
        //se i giocatori si trovano in una zona diversa dall'uscita,la probabilita che appaia gieson è del 30%
        else if(player->posizione->zona != uscita_campeggio && apparizione<=30){
            puts("");
            printf("\n\tIL CIELO È SERENO E NON C'È VENTO, MA SENTI UNO STRANO RUMORE. CREDI SIA UNO SCOIATTOLO\n\tMA QUANDO TI GIRI, LO SCENARIO È INQUIETANTE.\n\tÈ GIESON, NON SEMBRA CHE VOGLIA GIOCARE!\n");
            sleep(2);
            combattimento(player);
        }
        //se il giocatore si trova all'uscita la probabilità che appia gieson è del 75
        else if(player->posizione->zona == uscita_campeggio && apparizione<=75){
            puts("");
            printf("\n\tCREDEVI ORMAI DI ESSERE RIUSCITO A FUGGIRE DALL'INCUBO\n\tE DI LASCIARTI ALLA SPALLE QUESTA BRUTTA ESPERIENZA,\n\tMA GIESON APPARE POCO PRIMA CHE TU RIUSCISSI A FUGGIRE.\n\tCOSA ACCADRÀ ADESSO?\n");
            sleep(2);
            combattimento(player);
        }
        printf("\033[0m");
    }
}

static void usa_adrenalina(struct Giocatore *player){
    int a_on=0; //adrenalina on
    printf("\033[1;32m");
    if (player->zaino[adrenalina] == 0){
        printf("\n\t\tNON HAI DOSI DI ADRENALINA!\n");
        if (player == &marzia){
            gieson(&marzia);
        }
        else{
            gieson(&giacomo);
        }
    }
    else if (player->zaino[adrenalina] > 0){
        printf("\n\t\tLA DOSE INIZIA A FARE EFFETTO! HAI ALTRI DUE TURNI!\n");
        sleep(1);
        player->zaino[adrenalina]--;
        system("clear");
            if(player == &marzia){
                for (int i=0;i<2;i++){
                    if(marzia.stato == morto){
                        break;
                    }
                    system("clear");
                    turnomarzia();
                    if(marzia.stato != morto){
                        printf("\n\t\tTURNI SOTTO L'EFFETTO DELL'ADRENALINA: %d\n",i+1);
                        sleep(1);
                    }

                }
            }
            else{
                    for (int i=0;i<2;i++){
                        if(giacomo.stato == morto){
                            break;
                        }
                        system("clear");
                        turnogiacomo();
                        if(giacomo.stato != morto){
                            printf("\n\t\tTURNI SOTTO L'EFFETTO DELL'ADRENALINA: %d\n",i+1);
                            sleep(1);
                        }
                    }
            }
    }
    printf("\033[0m");
}

static void cura(struct Giocatore *player){
    printf("\033[1;32m");
       if (player->zaino[bende] == 0){
           printf("\n\tNON HAI ABBASTANZA BENDE!\n");
       }
       else if(player->stato == vivo){
           printf("\n\tNON HAI BISOGNO DI CURARTI!\n");
       }
       else if(player->stato == ferito){
           player->stato = vivo;
           player->zaino[bende]--;
           printf("\n\tLE TUE FERITE SONO STATE CURATE!\n");
       }
       printf("\033[0m");
}

static void prendi_oggetto(struct Zona* corrente,struct Giocatore *player){
    switch(corrente->oggetto){
            case cianfrusaglia:
                if(player->zaino[cianfrusaglia]<5){
                    player->zaino[cianfrusaglia]+=1;
                    corrente->oggetto=cianfrusaglia;
                    printf("\n\tCianfrusaglia aggiunta allo zaino!\n");
                    break;
                }
                else if (player->zaino[cianfrusaglia] == 5){
                    printf("\n\tNON PUOI TRASPORTARE PIÙ DI 5 CIANFRUSAGLIE!\n");
                    break;
                }
            case bende:
                if (player->zaino[bende]<5){
                    player->zaino[bende]+=1;
                    corrente->oggetto=cianfrusaglia;
                    printf("\n\tBenda aggiunta allo zaino!\n");
                    break;
                }
                else if (player->zaino[bende] == 5){
                    printf("\n\tNON PUOI TRASPORTARE PIÙ DI 5 BENDE!\n");
                    break;
                }
            case coltello:
                if (player->zaino[coltello]<10){
                player->zaino[coltello]+=1;
                corrente->oggetto=cianfrusaglia;
                printf("\n\tColtello aggiunto allo zaino!\n");
                break;
                }
                else if(player->zaino[coltello] == 10){
                    printf("\n\tNON PUOI TRASPORTARE PIÙ DI 10 COLTELLI!\n");
                    break;
                }
            case pistola:
                if (player->zaino[pistola]<3){
                player->zaino[pistola]+=1;
                corrente->oggetto=cianfrusaglia;
                printf("\n\tPistola aggiunta allo zaino!\n");
                break;
                }
                else if(player->zaino[pistola] == 3){
                    printf("\n\tNON PUOI TRASPORTARE PIÙ DI 3 PISTOLE!\n");
                    break;
                }
            case benzina:
                if (player->zaino[benzina]<5){
                player->zaino[benzina]+=1;
                corrente->oggetto=cianfrusaglia;
                printf("\n\tTanica di benzina aggiunta allo zaino!\n");
                break;
                }
                else if(player->zaino[benzina] == 5){
                    printf("\n\tNON PUOI TRASPORTARE PIÙ DI 5 TANICHE DI BENZINA!\n");
                    break;
                }
            case adrenalina:
                if (player->zaino[adrenalina]<5){
                player->zaino[adrenalina]+=1;
                corrente->oggetto=cianfrusaglia;
                printf("\n\tDose di adrenalina aggiunta allo zaino!\n");
                break;
                }
                else if(player->zaino[adrenalina] == 5){
                    printf("\n\tNON PUOI TRASPORTARE PIÙ DI 5 DOSI DI ADRENALINA!\n");
                    break;
                }
    }
}

static void mostra_oggetto(struct Zona* corrente){
    switch(corrente->oggetto){
            case cianfrusaglia:
                printf("\n\tper terra c'è un oggetto ma all'apparenza sembra inutile!\n");
                break;
            case bende:
                printf("\n\trovisti in tutti i cassetti riuscendo a trovare delle bende mediche!\n");
                break;
            case coltello:
                printf("\n\tvedi qualcosa luccicare,ti avvicini. È la lama di un coltello!\n");
                break;
            case pistola:
                printf("\n\tnon riesci a crederci! Cosa ci fa una pistola qui?!\n");
                break;
            case benzina:
                printf("\n\tc'è un odore strano nell'aria,ma quella è benzina!\n");
                break;
            case adrenalina:
                printf("\n\tci sono delle capsule sparse sul terreno. Quale sarà il loro effetto?\n");
                break;
    }
}

static void avanza(struct Giocatore *player){
        gieson(player);
        player->posizione = player->posizione->zona_successiva;

}

static void turnomarzia(){
    int scelta=0;
    printf("\033[1;31m");
    printf("\t+---------+------------+-----------+---------------+---------------+--------------+\n");
    printf("\t| NOME    | CONDIZIONE | POSIZIONE |    OGGETTO    |     ZAINO     |   QUANTITÀ   |\n");
    printf("\t+---------+------------+-----------+---------------+---------------+--------------+\n");
    printf("\t| MARZIA  |");
    switch (marzia.stato) {
        case vivo:
                 printf("   VIVA     |");
        break;
        case morto:
                 printf("   MORTA    |");
        break;
        case ferito:
                 printf("  FERITA    |");
        break;
        default:
        break;
    }
    switch(marzia.posizione->zona){
        case cucina:
                printf("  CUCINA   |");
        break;
        case soggiorno:
                printf(" SOGGIORNO |");
        break;
        case rimessa:
                printf("  RIMESSA  |");
        break;
        case strada:
                printf("  STRADA   |");
        break;
        case lungo_lago:
                printf("  LAGO     |");
        break;
        case uscita_campeggio:
                printf("  USCITA   |");
        break;
    }
    if (vistomarzia==0){
        printf("   NASCOSTO    |");
    }
    else{
        switch(marzia.posizione->oggetto){
                case cianfrusaglia:
                    printf(" CIANFRUSAGLIA |");
                    break;
                case bende:
                    printf("   BENDE       |");
                    break;
                case coltello:
                    printf("   COLTELLO    |");
                    break;
                case pistola:
                    printf("   PISTOLA     |");
                    break;
                case benzina:
                    printf("   BENZINA     |");
                    break;
                case adrenalina:
                    printf("   ADRENALINA  |");
                    break;
        }
    }
    //cancello uno spazio se quantita a due cifre,risolvo glitch grafico
    if(marzia.zaino[cianfrusaglia]>9){
    printf(" CIANFRUSAGLIA | x %d         |\n",marzia.zaino[cianfrusaglia]);
    }
    else{
     printf(" CIANFRUSAGLIA | x %d          |\n",marzia.zaino[cianfrusaglia]);
    }
    printf("\t|         |            |           |\t");
    if(marzia.zaino[bende]>9){
        printf("\t   | BENDE         | x %d         |\n",marzia.zaino[bende]);
    }
    else{
        printf("\t   | BENDE         | x %d          |\n",marzia.zaino[bende]);
    }
    printf("\t|         |            |           |\t");
    if(marzia.zaino[coltello]>9){
        printf("\t   | COLTELLO      | x %d         |\n",marzia.zaino[coltello]);
    }
    else{
        printf("\t   | COLTELLO      | x %d          |\n",marzia.zaino[coltello]);

    }
    printf("\t|         |            |           |\t");
    if(marzia.zaino[pistola]>9){
        printf("\t   | PISTOLA       | x %d         |\n",marzia.zaino[pistola]);
    }
    else{

        printf("\t   | PISTOLA       | x %d          |\n",marzia.zaino[pistola]);
    }
    printf("\t|         |            |           |\t");
    if(marzia.zaino[benzina]>9){
        printf("\t   | BENZINA       | x %d         |\n",marzia.zaino[benzina]);
    }
    else{

        printf("\t   | BENZINA       | x %d          |\n",marzia.zaino[benzina]);
    }
    printf("\t|         |            |           |\t");
    if(marzia.zaino[adrenalina]>9){
        printf("\t   | ADRENALINA    | x %d         |\n",marzia.zaino[adrenalina]);
    }
    else{
            printf("\t   | ADRENALINA    | x %d          |\n",marzia.zaino[adrenalina]);
    }

    printf("\t+---------+------------+-----------+---------------+---------------+--------------+\n");
    printf("\033[0m");
    puts("");
    printf("\tMARZIA ti trovi ");
    switch(marzia.posizione->zona){
        case cucina:
        printf("in cucina.\n\tCi sono delle macchie di olio per terra\n\thanno una forma particolare. Saranno impronte?\n\tNoti che dal set di coltelli ne manca uno,\n\tchi l'avrà preso?\n");
        break;
        case soggiorno:
        printf("nel soggiorno.\n\tLa struttura è fatiscente,per terra ci sono dei fogli,\n\tcredo servissero per la gestione del noleggio delle barche.\n\tC'è un computer sulla scrivania, GCC e ATOM sono aperti,\n\tprovi a compilare ma ti appare un WARNING.\n\tCosa significa?\n");
        break;
        case rimessa:
        printf("nella rimessa.\n\tLa struttura è in legno,ci sono vari utensili abbandonati,\n\tforse potresti trovare qualcosa di utile!\n");
        break;
        case strada:
        printf("per strada.\n\tÈ piena di buche,esatto il gioco è ambientato in Italia.\n\tCi sono dei veicoli abbandonati e delle scheggie di vetro per terra.\n\tFai attenzione!\n");
        break;
        case lungo_lago:
        printf("sulla riva del lago.\n\tQui un tempo venivano effettuate delle gite in barca,\n\tle acque del lago sono calme e limpide.\n\tAccanto ad un sasso sulla riva sono stati messi dei fiori,\n\tè tutto così strano.\n");
        break;
        case uscita_campeggio:
        printf("all'uscita del campeggio.\n\tOk mantieni la calma,\n\tnon è un miraggio ti trovi all'uscita.\n\tMancano soltanto pochi metri e potrai finalmente\n\tuscire e sostenenere l'esame di matematica discreta.\n\tIl creatore del gioco suggerisce di non avanzare,\n\tche rimanga tra noi,eh...\n");
        break;
    }
    puts("");
    printf("\033[1;31m");
    printf("\t\t\t\t1....................AVANZA\n\t\t\t\t2............MOSTRA OGGETTO\n\t\t\t\t3..........RACCOGLI OGGETTO\n\t\t\t\t4....................CURATI\n\t\t\t\t5.......UTILIZZA ADRENALINA\n\n\t\t\t\tSCELTA: ");
    while (scanf("%d",&scelta) != 1 || scelta<1 || scelta>5){
        printf("\033[1;31m");
            printf("\n\t\t\tSCELTA ERRATA! REINSERISCI IL VALORE: ");
            printf("\033[0m");
            while (getchar() != '\n');
        }
        printf("\033[0m");
    switch(scelta){
        case 1:
        if (marzia.posizione->zona == uscita_campeggio){
            gieson(&marzia);
            if(marzia.stato != morto){
                printf("\n\nCOMPLIMENTI,SEI RIUSCITA A SOPRAVVIVERE!\n");
                sleep(1);
                vittoriam =1;
                break;
            }
        }
            avanza(&marzia);
            vistomarzia =0;
        break;
        case 2:
        vistomarzia=1;
        mostra_oggetto(marzia.posizione);
        gieson(&marzia);
        break;
        case 3:
        if (vistomarzia ==0){
            printf("\033[1;32m");
            printf("\n\tNON PUOI RACCOGLIERE L'OGGETTO SENZA PRIMA AVERLO VISTO!\n");
            printf("\033[0");
            break;
        }
        prendi_oggetto(marzia.posizione,&marzia);
        vistomarzia =0;
        gieson(&marzia);
        break;
        case 4:
        cura(&marzia);
        gieson(&marzia);
        break;
        case 5:
        usa_adrenalina(&marzia);
        break;
        default:
        printf("\nSCELTA ERRATA!\n");
        break;
    }
}

static void turnogiacomo(){
    int scelta=0;
    printf("\033[0;34m");
    printf("\t+---------+------------+-----------+---------------+---------------+--------------+\n");
    printf("\t| NOME    | CONDIZIONE | POSIZIONE |    OGGETTO    |     ZAINO     |   QUANTITÀ   |\n");
    printf("\t+---------+------------+-----------+---------------+---------------+--------------+\n");
    printf("\t| GIACOMO |");
    switch (giacomo.stato) {
        case vivo:
                 printf("   VIVO     |");
        break;
        case morto:
                 printf("   MORTO    |");
        break;
        case ferito:
                 printf("  FERITO    |");
        break;
        default:
        break;
    }
    switch(giacomo.posizione->zona){
        case cucina:
                printf("  CUCINA   |");
        break;
        case soggiorno:
                printf(" SOGGIORNO |");
        break;
        case rimessa:
                printf("  RIMESSA  |");
        break;
        case strada:
                printf("  STRADA   |");
        break;
        case lungo_lago:
                printf("  LAGO     |");
        break;
        case uscita_campeggio:
                printf("  USCITA   |");
        break;
    }
    if (vistogiacomo==0){
        printf("   NASCOSTO    |");
    }
    else{
        switch(giacomo.posizione->oggetto){
                case cianfrusaglia:
                    printf(" CIANFRUSAGLIA |");
                    break;
                case bende:
                    printf("   BENDE       |");
                    break;
                case coltello:
                    printf("   COLTELLO    |");
                    break;
                case pistola:
                    printf("   PISTOLA     |");
                    break;
                case benzina:
                    printf("   BENZINA     |");
                    break;
                case adrenalina:
                    printf("   ADRENALINA  |");
                    break;
        }
    }
    //se quantità oggetto>9 la stampo con uno distanza in meno dal bordo della tabella,per una corretta visualizzazione
    if(giacomo.zaino[cianfrusaglia]>9){
        printf(" CIANFRUSAGLIA | x %d         |\n",giacomo.zaino[cianfrusaglia]);
    }
    else{
        printf(" CIANFRUSAGLIA | x %d          |\n",giacomo.zaino[cianfrusaglia]);
    }
    printf("\t|         |            |           |\t");
    if(giacomo.zaino[bende]>9){
            printf("\t   | BENDE         | x %d         |\n",giacomo.zaino[bende]);
    }
    else{
    printf("\t   | BENDE         | x %d          |\n",giacomo.zaino[bende]);
    }

    printf("\t|         |            |           |\t");
    if(giacomo.zaino[coltello]>9){
        printf("\t   | COLTELLO      | x %d         |\n",giacomo.zaino[coltello]);
    }
    else{
        printf("\t   | COLTELLO      | x %d          |\n",giacomo.zaino[coltello]);
    }
    printf("\t|         |            |           |\t");
    if(giacomo.zaino[pistola]>9){
        printf("\t   | PISTOLA       | x %d         |\n",giacomo.zaino[pistola]);
    }
    else{
        printf("\t   | PISTOLA       | x %d          |\n",giacomo.zaino[pistola]);
    }

    printf("\t|         |            |           |\t");
    if(giacomo.zaino[benzina]>9){
        printf("\t   | BENZINA       | x %d         |\n",giacomo.zaino[benzina]);
    }
    else{
        printf("\t   | BENZINA       | x %d          |\n",giacomo.zaino[benzina]);
    }
    printf("\t|         |            |           |\t");
    if(giacomo.zaino[adrenalina]>9){
        printf("\t   | ADRENALINA    | x %d         |\n",giacomo.zaino[adrenalina]);
    }
    else{
        printf("\t   | ADRENALINA    | x %d          |\n",giacomo.zaino[adrenalina]);
    }
    printf("\t+---------+------------+-----------+---------------+---------------+--------------+\n");
    puts("");
    printf("\033[0m");
    printf("\tGIACOMO ti trovi ");
    switch(giacomo.posizione->zona){
        case cucina:
        printf("in cucina.\n\tCi sono delle macchie di olio per terra\n\thanno una forma particolare. Saranno impronte?\n\tNoti che dal set di coltelli ne manca uno,\n\tchi l'avrà preso?\n");
        break;
        case soggiorno:
        printf("nel soggiorno.\n\tLa struttura è fatiscente,per terra ci sono dei fogli,\n\tcredo servissero per la gestione del noleggio delle barche.\n\tC'è un computer sulla scrivania, GCC e ATOM sono aperti,\n\tprovi a compilare ma ti appare un WARNING.\n\tCosa significa?\n");
        break;
        case rimessa:
        printf("nella rimessa.\n\tLa struttura è in legno,ci sono vari utensili abbandonati,\n\tforse potresti trovare qualcosa di utile!\n");
        break;
        case strada:
        printf("per strada.\n\tÈ piena di buche,esatto il gioco è ambientato in Italia.\n\tCi sono dei veicoli abbandonati e delle scheggie di vetro per terra.\n\tFai attenzione!\n");
        break;
        case lungo_lago:
        printf("sulla riva del lago.\n\tQui un tempo venivano effettuate delle gite in barca,\n\tle acque del lago sono calme e limpide.\n\tAccanto ad un sasso sulla riva sono stati messi dei fiori,\n\tè tutto così strano.\n");
        break;
        case uscita_campeggio:
        printf("all'uscita del campeggio.\n\tOk mantieni la calma,\n\tnon è un miraggio ti trovi all'uscita.\n\tMancano soltanto pochi metri e potrai finalmente\n\tuscire e sostenenere l'esame di matematica discreta.\n\tIl creatore del gioco suggerisce di non avanzare,\n\tche rimanga tra noi,eh...\n");
        break;
    }
    puts("");
    printf("\033[0;34m");
    printf("\t\t\t\t1....................AVANZA\n\t\t\t\t2............MOSTRA OGGETTO\n\t\t\t\t3..........RACCOGLI OGGETTO\n\t\t\t\t4....................CURATI\n\t\t\t\t5.......UTILIZZA ADRENALINA\n\n\t\t\t\tSCELTA: ");
    while (scanf("%d",&scelta) != 1 || scelta<1 || scelta>5){
        printf("\033[0;34m");
            printf("\n\t\t\tSCELTA ERRATA! REINSERISCI IL VALORE: ");
            printf("\033[0m");
            while (getchar() != '\n');
        }
        printf("\033[0m");
    switch(scelta){
        case 1:
        if (giacomo.posizione->zona == uscita_campeggio){
            gieson(&giacomo);
            if(giacomo.stato != morto){
                printf("\n\nCOMPLIMENTI,SEI RIUSCITO A SOPRAVVIVERE!\n");
                sleep(1);
                vittoriag=1;
                break;
            }
        }
        avanza(&giacomo);
        vistogiacomo =0;
        break;
        case 2:
        //se si mostra l'oggetto il vistogiacomo/marzia passa ad 1 il che significa che è possibile raccoglierlo il turno successivo
        vistogiacomo=1;
        mostra_oggetto(giacomo.posizione);
        gieson(&giacomo);
        break;
        case 3:
        //se il vistogiacomo/marzia è 0 significa che il player non ha ancora ricercato l'oggetto
        if (vistogiacomo ==0){
            printf("\033[1;32m");
            printf("\n\tNON PUOI RACCOGLIERE L'OGGETTO SENZA PRIMA AVERLO VISTO!\n");
            printf("\033[0m");
            break;
        }
        prendi_oggetto(giacomo.posizione,&giacomo);
        //una volta raccolto l'oggetto,il visto passa a 0
        vistogiacomo =0;
        gieson(&giacomo);
        break;
        case 4:
        cura(&giacomo);
        gieson(&giacomo);
        break;
        case 5:
        usa_adrenalina(&giacomo);
        break;
        default:
        printf("\nSCELTA ERRATA!\n");
        break;
    }
}

//gestisce randomicità dei turni e i vari stati in cui i giocatori si possono trovare (morte di uno o di entrambi,vincita di uno o di entrambi)
void gioca(){
    int inizio=0;
    time_t t;
    srand((unsigned) time(&t));
    if(prima_zona==NULL){
        printf("\033[1;31m");
        printf("\n\t\t\t  NESSUN PERCORSO DISPONIBILE!\n");
        sleep(1);
        printf("\033[0m");
        system("clear");
    }
    else{
        system("clear");
        do{
            //gestisce la randomicità del player che dovrà iniziare il turno
            //se inizio è<= 50 inizia marzia e finisce il turno giacomo altrimenti inizia giacomo e termina marzia
            inizio=1 + (rand() % 100);
           if (inizio<=50){
               //se entrambi hanno vinto,stampa un messaggio dealloca e resetta tutto e ritorna al menu inziale
                if(vittoriag == 1 && vittoriam ==1){
                    printf("\033[1;31m");
                   printf("\n\nCOMPLIMENTI,ENTRAMBI SIETE SOPRAVVISSUTI!\n");
                   printf("\033[0m");
                   //al termine del gioco gli zaini dei giocatori vengono resettati ,la memoria deallocata,il lucchetto diventa opened. Lo stesso discorso si applica anche in caso di vittoria/morte di uno o di entrambi i giocatori
                   termina_gioco();
                   //resetto gli zaini e le condizioni di salute dei giocatori
                   reset();
                   break;
               }
               //se giacomo ha vinto continua marzia,a meno che non sia morta
               else if(vittoriag == 1 && vittoriam == 0 && marzia.stato != morto){
                   puts("");
                   system("clear");
                   turnomarzia();
                   sleep(1);
                   puts("");
                   printf("\033[1;32m");
                   printf("\nTURNO COMPLETATO!\n");
                   printf("\033[0m");
                   sleep(1);
                   system("clear");
               }
               //se marzia ha vinto continua giacomo a meno che non sia morto
               else if(vittoriag == 0 && vittoriam == 1 && giacomo.stato != morto){
                   puts("");
                   system("clear");
                   turnogiacomo();
                   sleep(1);
                   puts("");
                   printf("\033[1;32m");
                   printf("\nTURNO COMPLETATO!\n");
                   printf("\033[0m");
                   sleep(1);
                   system("clear");
               }
               //se giacomo vince e marzia è morta,si stampa un messaggio,si dealloca e resetta tutto,in modo che si possa giocare una nuova partita
               else if(vittoriag ==1 && marzia.stato == morto){
                   printf("\033[1;31m");
                   printf("\n\nCOMPLIMENTI,SEI L'UNICO SOPRAVVISSUTO!\n");
                   printf("\033[0m");
                   termina_gioco();
                   reset();
                   break;
               }
                //se marzia vince e giacomo è morto,si stampa un messaggio,si dealloca e resetta tutto,in modo che si possa giocare una nuova partita
               else if(vittoriam ==1 && giacomo.stato == morto){
                   printf("\033[1;31m");
                   printf("\n\nCOMPLIMENTI,SEI L'UNICA SOPRAVVISSUTA!\n");
                   printf("\033[0m");
                   termina_gioco();
                   reset();
                   break;
               }
               //se entrambi sono vivi,i turni si alternano
               else if( marzia.stato != morto && giacomo.stato != morto ){
                   turnomarzia();
                   sleep(1);
                   system("clear");
                   turnogiacomo();
                   sleep(1);
                   puts("");
                   printf("\033[1;32m");
                   printf("\nTURNO COMPLETATO!\n");
                   printf("\033[0m");
                   sleep(1);
                   system("clear");
               }
               //se entrambi sono morti si stampa un messaggio,si dealloca e resetta tutto,in modo da poter avviare una nuova partita
               else if(giacomo.stato == morto && marzia.stato == morto){
                   system("clear");
                   printf("\033[1;31m");
                   printf("\n\t\t\tENTRAMBI I GIOCATORI SONO MORTI.\n\t\t\t\tGAME OVER!\n");
                   printf("\033[0m");
                   sleep(2);
                   termina_gioco();
                   reset();
                   break;
               }
               //se marzia è morta,continua giacomo
               else if(marzia.stato == morto){
                   system("clear");
                   turnogiacomo();
                   sleep(1);
                   puts("");
                   printf("\033[1;32m");
                   printf("\nTURNO COMPLETATO!\n");
                   printf("\033[0m");
                   sleep(1);
                   system("clear");
               }
               //se giacomo è morto continua marzia
               else if(giacomo.stato == morto){
                   system("clear");
                   turnomarzia();
                   sleep(1);
                   puts("");
                   printf("\033[1;32m");
                   printf("\nTURNO COMPLETATO!\n");
                   printf("\033[0m");
                   sleep(1);
                   system("clear");
               }

           }
           else{
               //lo stesso discorso analogo di sopra l'unica cosa che cambia è che se si entra nell'else significa
               //che il valore della variabile inizio è >50 dunque in condizioni ""normali"" inizia il turno giacomo e termina marzia
                if(vittoriag == 1 && vittoriam ==1){
                    printf("\033[1;31m");
                    printf("\n\n\t\tCOMPLIMENTI,ENTRAMBI SIETE SOPRAVVISSUTI!\n");
                    printf("\033[0m");
                    sleep(1);
                   termina_gioco();
                   reset();
                   break;
               }
               else if(vittoriag == 1 && vittoriam == 0 && marzia.stato != morto){
                   puts("");
                   system("clear");
                   turnomarzia();
                   sleep(1);
                   puts("");
                   printf("\033[1;32m");
                   printf("\nTURNO COMPLETATO!\n");
                   printf("\033[0m");
                   sleep(1);
                   system("clear");
               }
               else if(vittoriag == 0 && vittoriam == 1 && giacomo.stato != morto){
                   puts("");
                   system("clear");
                   turnogiacomo();
                   sleep(1);
                   puts("");
                   printf("\033[1;32m");
                   printf("\nTURNO COMPLETATO!\n");
                   printf("\033[0m");
                   sleep(1);
                   system("clear");
               }
               else if(vittoriag ==1 && marzia.stato == morto){
                   printf("\033[1;31m");
                   printf("\n\nCOMPLIMENTI,SEI L'UNICO SOPRAVVISSUTO!\n");
                   printf("\033[0m");
                   sleep(1);
                   termina_gioco();
                   reset();
                   break;
               }
               else if(vittoriam ==1 && giacomo.stato == morto){
                   printf("\033[1;31m");
                   printf("\n\nCOMPLIMENTI,SEI L'UNICA SOPRAVVISSUTA!\n");
                   printf("\033[0m");
                   sleep(1);
                   termina_gioco();
                   reset();
                   break;
               }
               else if(marzia.stato != morto && giacomo.stato != morto){
                   turnogiacomo();
                   sleep(1);
                   system("clear");
                   turnomarzia();
                   puts("");
                   sleep(1);
                   printf("\033[1;32m");
                   printf("\nTURNO COMPLETATO!\n");
                   printf("\033[0m");
                   sleep(1);
                   system("clear");
               }
               else if(giacomo.stato == morto && marzia.stato == morto){
                   system("clear");
                   printf("\033[1;31m");
                   printf("\n\t\t\tENTRAMBI I GIOCATORI SONO MORTI.\n\t\t\t\tGAME OVER!\n");
                   printf("\033[0m");
                   sleep(2);
                   termina_gioco();
                   reset();
                   break;
               }
               else if(marzia.stato == morto){
                   system("clear");
                   turnogiacomo();
                   sleep(1);
                   puts("");
                   printf("\033[1;32m");
                   printf("\nTURNO COMPLETATO!\n");
                   printf("\033[0m");
                   sleep(1);
                   system("clear");
               }
               else if(giacomo.stato == morto){
                   system("clear");
                   turnomarzia();
                   sleep(1);
                   puts("");
                   printf("\033[1;32m");
                   printf("\nTURNO COMPLETATO!\n");
                   printf("\033[0m");
                   sleep(1);
                   system("clear");
               }
           }
       }while(1);
}
}


void crea_mappa(){
    short int sceltat=0;
    do{
        printf("\033[0;31m");
        printf("\t\t╔═╗╦═╗╔═╗╔═╗  ╦╦    ╔╦╗╦ ╦╔═╗  ╔═╗╔═╗╦═╗╔═╗╔═╗╦═╗╔═╗╔═╗\n");
        printf("\t\t║  ╠╦╝║╣ ╠═╣  ║║     ║ ║ ║║ ║  ╠═╝║╣ ╠╦╝║  ║ ║╠╦╝╚═╗║ ║\n");
        printf("\t\t╚═╝╩╚═╚═╝╩ ╩  ╩╩═╝   ╩ ╚═╝╚═╝  ╩  ╚═╝╩╚═╚═╝╚═╝╩╚═╚═╝╚═╝\n");
        printf("\t\t        ╦  ╦╔═╗╦═╗╔═╗╔═╗  ╦  ╔═╗  ╔╦╗╔═╗╦═╗╔╦╗╔═╗      \n");
        printf("\t\t        ╚╗╔╝║╣ ╠╦╝╚═╗║ ║  ║  ╠═╣  ║║║║ ║╠╦╝ ║ ║╣       \n");
        printf("\t\t         ╚╝ ╚═╝╩╚═╚═╝╚═╝  ╩═╝╩ ╩  ╩ ╩╚═╝╩╚═ ╩ ╚═╝      \n");
        printf("\033[0m");
        printf("\033[1;36m");
        printf("\n\n\t\t\t\t1......INSERISCI ZONA\n\t\t\t\t2.......CANCELLA ZONA\n\t\t\t\t3........STAMPA MAPPA\n\t\t\t\t4........CHIUDI MAPPA\n\t\t\t\t5......TORNA INDIETRO\n\n\t\t\t\tSCELTA: ");
        printf("\033[0m");
    while (scanf("%hu",&sceltat) != 1 || sceltat >5|| sceltat <1){
        printf("\033[1;36m");
        printf("\n\t\t\tSCELTA NON CORRETTA! REINSERISCI IL VALORE: ");
        printf("\033[0m");
        while (getchar() != '\n');
    }
    switch(sceltat){
            case 1:
                  system("clear");
                  ins_zona();
            break;
            case 2:
                  canc_zona();
                  sleep(1);
                  system("clear");
            break;
            case 3:
                  stampa_mappa();
                  system("clear");
            break;
            case 4:
                  printf("\n");
                  chiudi_mappa();
                  system("clear");
            break;
            case 5:
            printf("\033[1;36m");
            if(prima_zona==NULL){
                printf("\n\t\t\tPRIMA DI GIOCARE,COSTRUISCI LA MAPPA!\n");
                sleep(2);
                system("clear");
                crea_mappa();
            }
            else if(lucchetto == opened){
                printf("\n\t\tNON PUOI INIZIARE A GIOCARE SE PRIMA NON CHIUDI LA MAPPA!\n");
                sleep(2);
                system("clear");
                crea_mappa();
            }
            system("clear");
            break;
            default:
            system("clear");
            printf("\n\tLA SCELTA INSERITA NON È VALIDA! SCEGLI DI NUOVO...\n");
            sleep(2);
            printf("\033[0m");
            break;
      }
     // printf("\nZONE: %d\n",numeronodi);
  }while(sceltat!=5);
}

static void canc_zona(){
   struct Zona *codatemp=NULL;
   codatemp=prima_zona;
   printf("\033[1;36m");
   if(prima_zona == NULL){
       printf("\n\t\t\tNON HAI ANCORA INSERITO NESSUNA ZONA!\n");
       sleep(1);
   }
   else if(codatemp->zona_successiva == NULL){
           printf("\n\t\t\tNON PUOI ELIMINARE LA PRIMA ZONA!\n");
            sleep(1);
       }
       else{
           numeronodi--;
           lucchetto = opened;
           while (codatemp->zona_successiva !=NULL){
               ultima_zona = codatemp;
               codatemp=codatemp->zona_successiva;
           }
           free(codatemp);
           ultima_zona->zona_successiva=NULL;
           printf("\033[1;36m");
           printf("\n\t\t\t  ULTIMA ZONA CANCELLATA CORRETTAMENTE!\n");
           printf("\033[0m");
       }
   }

static enum Tipo_oggetto p_oggetto(enum Tipo_zona zona,int probabilita){
          int somma=0; //contiene la somma di tutte le probabilita in MATRICE di una riga
          if(probabilita<=mat[zona][0]){
              return cianfrusaglia;
          }
          else{
                for(int i=0;i<6;i++){
                    somma += mat[zona][i];
                    //verifico in quale range è compresa la probabilita e in quale riga(zona) mi trovo
                     if(i==1 && probabilita<=somma){
                        return bende;
                    }
                    else if(i==2 && probabilita<=somma){
                        return coltello;
                    }
                    else if(i==3 && probabilita<=somma){
                        return pistola;
                    }
                    else if(i==4 && probabilita<=somma){
                        return benzina;
                    }
                    else if(i==5 && probabilita<=somma){
                        return adrenalina;
                    }
                }
          }
}

static void ins_zona(){
    time_t t;
    srand((unsigned) time(&t));
    short int numerozone=0;
    int probabilita = 0;
    int continua=0;
    struct Zona *nuovazona=NULL,*uscita = NULL;
    uscita = (struct Zona*) malloc (sizeof(struct Zona));
    uscita->zona_successiva = NULL;

    if(prima_zona !=NULL){
            if (ultima_zona->zona == uscita_campeggio){
                canc_zona();
            }
            printf("\033[1;31m");
            printf("\n\tL'USCITA PRECEDENTE,SE PRESENTE, VERRÀ CANCELLATA ED UNA VOLTA TERMINATA LA MODIFICA\n\tVERRÀ INSERITA UNA NUOVA USCITA!\n");
            printf("\033[0m");
        do{
            struct Zona *singolazona=NULL;
            singolazona = (struct Zona*) malloc (sizeof(struct Zona));
            singolazona->zona_successiva =NULL;
            probabilita= 1 + (rand() % 100);
            printf("\033[1;31m");
            printf("\n\tINSERISCI LA TIPOLOGIA DELLA ZONA\n\t(0=CUCINA,1=SOGGIORNO,2=RIMESSA,3=STRADA,4=LAGO)\n\n\tSCELTA: ");

            while (scanf("%d",&singolazona->zona) != 1 || singolazona->zona>4 || singolazona->zona <0){
                    printf("\n\tSCELTA NON CORRETTA! REINSERISCI LA SCELTA: ");
                    while (getchar() != '\n');
                }
            singolazona->oggetto = p_oggetto(singolazona->zona,probabilita);
            ultima_zona ->zona_successiva = singolazona;
            ultima_zona = singolazona;
            numeronodi++;
            lucchetto = opened;
            printf("\n\tDigita -1 per uscire oppure qualsiasi altro tasto per continuare: ");
            while(scanf("%d",&continua) !=1){
                printf("\033[1;31m");
                printf("\n\tSCELTA NON CORRETTA! REINSERISCI IL VALORE: ");
                printf("\033[0m");
                while (getchar() != '\n');
            }
        }while(continua!=-1);
        //se il numero di zone è minimo 7,aggiungo automaticamente l'uscita
        if (numeronodi>=7){
            numeronodi++;
            uscita->zona =uscita_campeggio;
            uscita->oggetto = p_oggetto(uscita_campeggio,probabilita);
            ultima_zona->zona_successiva = uscita;
            ultima_zona= uscita;
        }
        printf("\n\tPERCORSO MODIFICATO CORRETTAMENTE!\n");
        sleep(1);
        system("clear");
        printf("\033[0m");
    }
    else{
            printf("\033[0;31m");
            printf("\n\tIL NUMERO MINIMO DI ZONE È 8 E L'USCITA VERRÀ AGGIUNTA AUTOMATICATICAMENTE.\n\n\tQUANTE ZONE VUOI INSERIRE? ");
            while (scanf("%hu",&numerozone) != 1 || numerozone<7){
                printf("\n\tSCELTA NON CORRETTA! REINSERISCI IL VALORE: ");
                while (getchar() != '\n');
                printf("\033[0m");
        }


            for (int i=0;i<numerozone;i++){
                printf("\033[1;31m");
                numeronodi++;
                nuovazona = (struct Zona*) malloc (sizeof(struct Zona));
                probabilita= 1 + (rand() % 100);
                printf("\n\tINSERISCI LA TIPOLOGIA DELLA ZONA\n\t(0=CUCINA,1=SOGGIORNO,2=RIMESSA,3=STRADA,4=LAGO)\n\n\tSCELTA: ");
                while (scanf("%d",&nuovazona->zona) != 1 || nuovazona->zona>4 || nuovazona->zona <0){
                        printf("\033[1;31m");
                        printf("\n\tSCELTA NON CORRETTA! REINSERISCI IL VALORE: ");
                        printf("\033[0m");
                        while (getchar() != '\n');
                    }
                nuovazona->oggetto = p_oggetto(nuovazona->zona,probabilita);
                nuovazona->zona_successiva =NULL;
                if(prima_zona == NULL ) {
                    prima_zona = nuovazona;
                    ultima_zona = prima_zona;
                    giacomo.posizione= prima_zona;
                    marzia.posizione= prima_zona;
                }
                else{
                    ultima_zona ->zona_successiva = nuovazona;
                    ultima_zona = ultima_zona->zona_successiva;
                }
                printf("\033[1;31m");
        }
        numeronodi++;
        uscita->zona =uscita_campeggio;
        uscita->oggetto = p_oggetto(uscita_campeggio,probabilita);
        ultima_zona->zona_successiva = uscita;
        ultima_zona= uscita;
        printf("\033[1;31m");
        printf("\n\tATTENDI...\n");
        sleep(2);
        printf("\tPERCORSO CREATO CORRETTAMENTE!\n");
        sleep(1);
        system("clear");
        printf("\033[0m");
    }
}

static void stampa_mappa()
{
    //ho preferito l'utilizzo di due array di char contenenti la tipologia della zona e l'oggetto al suo interno
    //per poter integrare al meglio la loro stampa in una tabella
    char tipoZ[20]={0}; // array per gestire il passaggio da enum a stringa
    char tipoO[20]={0};
    if(prima_zona == NULL){
        printf("\033[1;36m");
        printf("\n\t\t\t\tIL PERCORSO È VUOTO!\n");
        sleep(1);
        printf("\033[0m");
    }
    else{
        struct Zona *temp = prima_zona;
        printf("\033[1;33m");
        printf("\n\t\t\t+-------------+---------------+\n");
        printf("\t\t\t|    ZONA     |    OGGETTO    |\n");
        printf("\t\t\t+-------------+---------------+\n");
        printf("\033[0m");
        while(temp!=NULL){
            switch(temp->zona){
                //in base al contenuto del campo zona,con strcpy inserisco nell'array di char tipoZ la corrispettiva tipologia della zona
                case 0:
                /*strcpy copia la stringa nell'array di char*/
                strcpy(tipoZ,"CUCINA    |");
                break;
                case 1:
                strcpy(tipoZ,"SOGGIORNO |");
                break;
                case 2:
                strcpy(tipoZ,"RIMESSA   |");
                break;
                case 3:
                strcpy(tipoZ,"STRADA    |");
                break;
                case 4:
                strcpy(tipoZ,"LAGO      |");
                break;
                case 5:
                strcpy(tipoZ,"USCITA    |");
                break;
                default:
                break;
            }
            switch(temp->oggetto){
                //in base al contenuto del campo oggetto,con strcpy inserisco nell'array di char tipoO il corrispettivo oggetto
                case 0:
                strcpy(tipoO,"CIANFRUSAGLIA |");
                break;
                case 1:
                strcpy(tipoO,"BENDE         |");
                break;
                case 2:
                strcpy(tipoO,"COLTELLO      |");
                break;
                case 3:
                strcpy(tipoO,"PISTOLA       |");
                break;
                case 4:
                strcpy(tipoO,"BENZINA       |");
                break;
                case 5:
                strcpy(tipoO,"ADRENALINA    |");
                break;
                default:
                break;
            }
            //stampo i due array di char contenenti la tipologia della zona e l'oggetto al suo interno
            printf("\033[1;33m");
            printf("\t\t\t|   %s %s\n",tipoZ,tipoO);
            printf("\033[0m");
            //stampo i dati di una zona,una volta terminato passo a alla stampa della zona successiva e così via fino a quando temp == NULL dunque ho stampato tutte le zone
            temp= temp->zona_successiva;
        }
        printf("\033[1;33m");
        printf("\t\t\t+-------------+---------------+");
        printf("\033[0m");
        puts("");
        puts("");
        sleep(3);
    }
}

static void chiudi_mappa(){
    printf("\033[1;36m");
    if(prima_zona == NULL){
        printf("\t\t\t\tIL PERCORSO È VUOTO!\n");
        sleep(1);
    }
     else if (numeronodi <8){
         printf("\t\t  NON PUOI CHIUDERE IL PERCORSO CON MENO DI 8 ZONE!\n");
         sleep(1);
     }
     else if(ultima_zona->zona != uscita_campeggio){
         printf("\t\t\t\tNON È PRESENTE L'USCITA!\n");
         sleep(1);
     }
    else if(lucchetto==closed){
        printf("\t\t\tPERCORSO GIÀ CHIUSO,PUOI GIOCARE!\n");
        sleep(1);
    }
    else if (lucchetto == opened){
        //se tutte le condizioni sono rispettate,il percorso viene chiuso correttamente ed il lucchetto diventa closed
                printf("\t\t\tLA MAPPA È STATA CHIUSA CORRETTAMENTE!\n");
                sleep(1);
                lucchetto = closed;
                printf("\t\t\tADESSO PUOI INIZIARE A GIOCARE! ...\n");
                sleep(1);
            }
    printf("\033[0m");
}
